'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calendarOnlyProps = undefined;

var _pick2 = require('lodash/pick');

var _pick3 = _interopRequireDefault(_pick2);

exports.default = disabledTime;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var calendarOnlyProps = exports.calendarOnlyProps = ['disabledHours', 'disabledMinutes', 'disabledSeconds', 'hideHours', 'hideHours', 'hideMinutes', 'hideSeconds'];

function disabledTime(props, date) {
  if (!date) {
    return false;
  }

  var calendarProps = (0, _pick3.default)(props, calendarOnlyProps);

  return Object.keys(calendarProps).some(function (key) {
    if (/(Hours)/.test(key)) {
      return calendarProps[key](date.hours(), date);
    }
    if (/(Minutes)/.test(key)) {
      return calendarProps[key](date.minutes(), date);
    }
    if (/(Seconds)/.test(key)) {
      return calendarProps[key](date.seconds(), date);
    }
    return false;
  });
}