'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = scrollTopAnimation;

var _domLib = require('dom-lib');

var _requestAnimationFramePolyfill = require('dom-lib/lib/animation/requestAnimationFramePolyfill');

var _requestAnimationFramePolyfill2 = _interopRequireDefault(_requestAnimationFramePolyfill);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function scrollTopAnimation(target, nextTop) {
  var animation = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
  var callback = arguments[3];

  var top = (0, _domLib.scrollTop)(target);
  var step = function step() {
    (0, _domLib.scrollTop)(target, top > nextTop ? nextTop : top);
    if (top <= nextTop) {
      (0, _requestAnimationFramePolyfill2.default)(step);
    }
    callback && callback(top);
    top += 20;
  };
  if (animation) {
    (0, _requestAnimationFramePolyfill2.default)(step);
  } else {
    (0, _domLib.scrollTop)(target, nextTop);
  }
}